# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from abb_robot_msgs/RAPIDTaskState.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class RAPIDTaskState(genpy.Message):
  _md5sum = "37a1a82a542dcaea43aef8b824e26614"
  _type = "abb_robot_msgs/RAPIDTaskState"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """#-------------------------------------------------------------------------------
# Description:
#   The purpose of this message definition, is to represent a subset of states
#   of a RAPID task defined in an ABB robot controller system.
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
# Enumerations
#-------------------------------------------------------------------------------
# RAPID execution states:
uint8 EXECUTION_STATE_UNKNOWN       = 1
uint8 EXECUTION_STATE_READY         = 2
uint8 EXECUTION_STATE_STOPPED       = 3
uint8 EXECUTION_STATE_STARTED       = 4
uint8 EXECUTION_STATE_UNINITIALIZED = 5

#-------------------------------------------------------------------------------
# Message fields
#-------------------------------------------------------------------------------
# The RAPID task's name.
string name

# The RAPID task's activated/deactivated status.
bool activated

# The RAPID task's execution state.
uint8 execution_state

# The RAPID task is a motion task.
bool motion_task
"""
  # Pseudo-constants
  EXECUTION_STATE_UNKNOWN = 1
  EXECUTION_STATE_READY = 2
  EXECUTION_STATE_STOPPED = 3
  EXECUTION_STATE_STARTED = 4
  EXECUTION_STATE_UNINITIALIZED = 5

  __slots__ = ['name','activated','execution_state','motion_task']
  _slot_types = ['string','bool','uint8','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       name,activated,execution_state,motion_task

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RAPIDTaskState, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.name is None:
        self.name = ''
      if self.activated is None:
        self.activated = False
      if self.execution_state is None:
        self.execution_state = 0
      if self.motion_task is None:
        self.motion_task = False
    else:
      self.name = ''
      self.activated = False
      self.execution_state = 0
      self.motion_task = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3B().pack(_x.activated, _x.execution_state, _x.motion_task))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      _x = self
      start = end
      end += 3
      (_x.activated, _x.execution_state, _x.motion_task,) = _get_struct_3B().unpack(str[start:end])
      self.activated = bool(self.activated)
      self.motion_task = bool(self.motion_task)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3B().pack(_x.activated, _x.execution_state, _x.motion_task))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      _x = self
      start = end
      end += 3
      (_x.activated, _x.execution_state, _x.motion_task,) = _get_struct_3B().unpack(str[start:end])
      self.activated = bool(self.activated)
      self.motion_task = bool(self.motion_task)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3B = None
def _get_struct_3B():
    global _struct_3B
    if _struct_3B is None:
        _struct_3B = struct.Struct("<3B")
    return _struct_3B
